<?xml version="1.0" encoding="UTF-8"?>
<!--
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) ENPC - Jean-Philippe Chancelier
 * Copyright (C) 2008 - INRIA - Vincent COUVERT
 * 
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at    
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 -->
<refentry version="5.0-subset Scilab" xml:id="xclick" xml:lang="en"
          xmlns="http://docbook.org/ns/docbook"
          xmlns:xlink="http://www.w3.org/1999/xlink"
          xmlns:svg="http://www.w3.org/2000/svg"
          xmlns:ns3="http://www.w3.org/1999/xhtml"
          xmlns:mml="http://www.w3.org/1998/Math/MathML"
          xmlns:db="http://docbook.org/ns/docbook">
  <info>
    <pubdate>$LastChangedDate: 2008-03-26 09:50:39 +0100 (mer, 26 mar 2008)
    $</pubdate>
  </info>

  <refnamediv>
    <refname>xclick</refname>

    <refpurpose>Wait for a mouse click.</refpurpose>
  </refnamediv>

  <refsynopsisdiv>
    <title>Calling Sequence</title>

    <synopsis>[ibutton,xcoord,yxcoord,iwin,cbmenu]=xclick([flag])</synopsis>
  </refsynopsisdiv>

  <refsection>
    <title>Parameters</title>

    <variablelist>
      <varlistentry>
        <term>ibutton</term>

        <listitem>
          <para>Real scalar (integer value): mouse button number, key code...
          (See description below).</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>xcoord</term>

        <listitem>
          <para>Real scalar: x-ccordinate of the mouse pointer when the clic
          occured, in current graphic scale.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ycoord</term>

        <listitem>
          <para>Real scalar: x-ccordinate of the mouse pointer when the clic
          occured, in current graphic scale.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>iwin</term>

        <listitem>
          <para>Real scalar (integer value): number of the window where the
          action occured.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>cbmenu</term>

        <listitem>
          <para>String: callback associated to a menu if
          <literal>xclick</literal> returns due to a click on a menu. In this
          case, <literal>ibutton</literal>, <literal>xcoord</literal>,
          <literal>ycoord</literal>, and <literal>iwin</literal> take
          arbitrary values.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>flag</term>

        <listitem>
          <para>Real scalar (integer value): If present, the click event queue
          is not cleared when entering xclick.</para>
        </listitem>
      </varlistentry>
    </variablelist>
  </refsection>

  <refsection>
    <title>Description</title>

    <para><literal>xclick</literal> waits for a mouse click in the graphics
    window.</para>

    <para>If it is called with 3 left hand side arguments, it waits for a
    mouse click in the current graphics window.</para>

    <para>If it is called with 4 or 5 left hand side arguments, it waits for a
    mouse click in any graphics window.</para>

    <para>The values of <literal>ibutton</literal> are described below.</para>

    <variablelist>
      <varlistentry>
        <term>ibutton==0</term>

        <listitem>
          <para>Left mouse button has been pressed.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==1</term>

        <listitem>
          <para>Middle mouse button has been pressed.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==2</term>

        <listitem>
          <para>Right mouse button has been pressed.</para>

          <para></para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==3</term>

        <listitem>
          <para>Left mouse button has been clicked.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==4</term>

        <listitem>
          <para>Middle mouse button has been clicked.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==5</term>

        <listitem>
          <para>Right mouse button has been clicked.</para>

          <para></para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==10</term>

        <listitem>
          <para>Left mouse button has been double-clicked.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==11</term>

        <listitem>
          <para>Middle mouse button has been double-clicked.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==12</term>

        <listitem>
          <para>Right mouse button has been double-clicked.</para>

          <para></para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton &gt;=32</term>

        <listitem>
          <para>key with ASCII code <literal>ibutton</literal> has been
          pressed.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton &lt;=32</term>

        <listitem>
          <para>key with ASCII code <literal>-ibutton</literal> has been
          released.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton &gt;=1000+32</term>

        <listitem>
          <para>key with ASCII code <literal>ibutton-1000</literal> has been
          pressed while CTRL key pressed.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==-1000</term>

        <listitem>
          <para>graphic window has been closed.</para>

          <para>WARNING: <literal>ibutton</literal> was equal to -100 for
          graphic window closure up to Scilab 4.1.2, but this code has been
          changed (in Scilab 5.0) because it was also the code returned for
          <literal>d</literal> key release.</para>
        </listitem>
      </varlistentry>

      <varlistentry>
        <term>ibutton==-2</term>

        <listitem>
          <para>A dynamic menu has been selected and its callback is returned
          in <literal>cbmenu</literal>.</para>
        </listitem>
      </varlistentry>
    </variablelist>
  </refsection>

  <refsection>
    <title>See Also</title>

    <simplelist type="inline">
      <member><link linkend="locate">locate</link></member>

      <member><link linkend="xgetmouse">xgetmouse</link></member>

      <member><link linkend="seteventhandler">seteventhandler</link></member>
    </simplelist>
  </refsection>

  <refsection>
    <title>Authors</title>

    <para>J.Ph.C.</para>

    <para>V.C.</para>
  </refsection>
</refentry>